#if !defined(_MAIN_H)
#define _MAIN_H
#define PIN_LED 25

#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <WiFi.h>
#include <ezTime.h>
#include <webserver.h>
#include <DNSServer.h>

#include <PubSubClient.h>
#include <RadioLib.h>

#ifdef DEBUG
  #define dbg(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define err(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define info(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define warn(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
#else
  #define dbg(format, arg...) do {} while (0)
  #define err(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define info(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
  #define warn(format, arg...) {printf("%s:%d " format , __FILE__ , __LINE__ , ## arg);}
#endif

// // #define RADIOLIB_EXCLUDE_RF69             (1)
// #define RADIOLIB_EXCLUDE_SX1231           (1) // dependent on RADIOLIB_EXCLUDE_RF69
// #define RADIOLIB_EXCLUDE_SI443X           (1)
// #define RADIOLIB_EXCLUDE_RFM2X            (1) // dependent on RADIOLIB_EXCLUDE_SI443X
// // #define RADIOLIB_EXCLUDE_SX127X           (1)
// // #define RADIOLIB_EXCLUDE_SX126X           (1)
// #define RADIOLIB_EXCLUDE_STM32WLX         (1) // dependent on RADIOLIB_EXCLUDE_SX126X
// #define RADIOLIB_EXCLUDE_SX128X           (1)
// #define RADIOLIB_EXCLUDE_AFSK             (1)
// #define RADIOLIB_EXCLUDE_AX25             (1)
// #define RADIOLIB_EXCLUDE_HELLSCHREIBER    (1)
// #define RADIOLIB_EXCLUDE_MORSE            (1)
// #define RADIOLIB_EXCLUDE_APRS             (1)
// #define RADIOLIB_EXCLUDE_RTTY             (1)
// #define RADIOLIB_EXCLUDE_SSTV             (1)
// // #define RADIOLIB_EXCLUDE_DIRECT_RECEIVE   (1)
// #define RADIOLIB_LOW_LEVEL 1
// #define RADIOLIB_GODMODE 1
//
// #define POCSAG_DEBUG 1
// #define POCSAG_DEBUG_PORT Serial
#include <pocsag_transmitter.h>
#include <board.h>
#include <config.h>
#ifdef SMART_POC_MODULE_DWD
#include <dwd.h>
#endif
#ifdef SMART_POC_MODULE_MOWAS
#include <mowas.h>
#endif
#ifdef SMART_POC_DISPLAY
#include <display.h>
#else
#include <WiFi.h>
#endif

void txControllerBatchClear();
void txControllerBatchStart();
int txControllerBatchQueueCount();
String txHandleUmlauts(String message);
void txControllerInsert(uint32_t ric, uint8_t functionBit, char *text);
void setup_radio();
void setup_network();
void setup_mqtt();
void setup_broadcasts();
void setup_leds();
//
void mqtt_callback(char* topic, byte* payload, unsigned int length);
//
void broadcast_loop();
void broadcastTriggerTimeBeacon();
void heap_loop();
#endif